#include <iostream>
#include <list>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <algorithm>
//
#include <stdio.h>
#include <assert.h>
#include <string.h>

#include "Solver.h"
#include "SimpSolver.h"
using namespace std;

#include "d0efs.hh"

//
//  ADD_SAT_XLIT
//
void EgPqe::add_sat_xlit(CLAUSE &B,CLAUSE &C)
{

  MboolVec &S = Slvr->model;
  for (uint i=0; i < C.size(); i++) {
    int var_ind = abs(C[i])-1;
    if (Xvar[var_ind] == 0) continue;
    int lit = var_ind+1;
    if (S[var_ind] != Mtrue)
      lit = -lit;
    if (C[i] == lit) {
      B.push_back(C[i]);
      return;      
    }
  }
  p();
  print_symb_cube(B);
  print_symb_cube(C);
  CUBE A;
  form_sat_assgn(A,Slvr);
  print_symb_cube(A);
  exit(ERROR);
  
} /* add_sat_xlit */




//
// GEN_IMPL_CLS
//
void EgPqe::gen_impl_cls(CLAUSE &D,MvecLits &Assmps)
{
 
  for (int i=0; i < Assmps.size(); i++) {
    Mlit L = ~Assmps[i];   
    if (Slvr->conflict.has(L)) {
      int lit = mlit_to_lit(Slvr,L);
      D.push_back(lit);
    }
  }
        

} /* gen_impl_cls */




