#include <iostream>
#include <list>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <algorithm>
//
#include <stdio.h>
#include <assert.h>
#include <string.h>

#include "Solver.h"
#include "SimpSolver.h"
using namespace std;

#include "d0efs.hh"

//
// PRINT_SYMB_CUBE1
//
void EgPqe::print_symb_cube1(FILE *fp,CUBE &A,bool cr)
{
  

  for (uint i=0; i < A.size(); i++) {
    if (i > 0) fprintf(fp," ");
    int &lit = A[i];
    if (lit < 0) fprintf(fp,"~");
    int var_ind = abs(lit)-1;
    if (Xvar[var_ind]) fprintf(fp,"x");
    else fprintf(fp,"y");
    fprintf(fp,"%d",var_ind+1);
  }

  if (cr) fprintf(fp,"\n");
} /* print_symb_cube1 */

//
//  PRINT_SYMB_CUBE
//

void EgPqe::print_symb_cube(CUBE &A,bool cr)
{

  print_symb_cube1(stdout,A,cr);

} /* print_symb_cube2 */


//
//  DROP_YVARS
//
void EgPqe::drop_yvars(CNF &A,CNF &B)
{

  for (uint i=0; i < B.size(); i++) {
    CLAUSE &C1 = B[i];
    CLAUSE C2;
    for (uint j=0; j < C1.size(); j++) {
      int var_ind = abs(C1[j])-1;
      if (Xvar[var_ind] == 0) continue;
      C2.push_back(C1[j]);
    }
    A.push_back(C2);
  }

} /* drop_yvars */
